
#include <unistd.h>
#include "globdef.h"
#include "uidef.h"
#include "fft1def.h"
#include "foldcorr.h"
#include "screendef.h"
#include "caldef.h"
#include "seldef.h"
#include "thrdef.h"

#define FRESH_RECALC 8


void fix2_dspnames(char *s,int i)
{
s[i]='c';  
s[i+1]='o';
s[i+2]='r';
s[i+3]='r';
s[i+4]=0;
s[0]='d';
s[1]='s';
s[2]='p';
}


int fix1_dspnames(char *s)
{
int i;
i=0;
while(rxpar_filenames[rx_mode][i] != 0)
  {
  s[i]=rxpar_filenames[rx_mode][i];
  i++;
  }
s[i]='_';
i++;  
return i;
}



void make_iqcorr_filename(char *s)
{
int i;
i=fix1_dspnames(s);
s[i]='i';
s[i+1]='q';
i+=2;
fix2_dspnames(s,i);
}  


void make_filfunc_filename(char *s)
{
int i;
i=fix1_dspnames(s);
fix2_dspnames(s,i);
}  

void update_fft1_slowsum(void)
{
int i,ia,pa,pb;
// Now that we have a new power spectrum in fft1_sumsq, update the
// average of the spectra in fft1_slowsum by adding it's power and 
// subtracting the power of the old one that should no longer 
// contribute to the sum.  
// This way of calculating an average may cause errors after a long
// time since bits may be lost occasionally due to rounding errors.
// Calculate a few points from scratch each time to eliminate this
// problem. 
pa=fft1_sumsq_pws;
pb=(pa-wg_fft_avg2num*fft1_size+fft1_sumsq_bufsize)&fft1_sumsq_mask;
if(fft1_sumsq_recalc == fft1_last_point) fft1_sumsq_recalc=fft1_first_point;
ia=fft1_sumsq_recalc;
fft1_sumsq_recalc+=wg.xpoints/FRESH_RECALC;
if(fft1_sumsq_recalc>fft1_last_point)fft1_sumsq_recalc=fft1_last_point;
new_fft1_averages(ia,fft1_sumsq_recalc);
for(i=fft1_first_point; i < ia; i++)
  {
  fft1_slowsum[i]+=fft1_sumsq[pa+i]-fft1_sumsq[pb+i];
  if(fft1_slowsum[i]<0)fft1_slowsum[i]=0;
  }
for(i=fft1_sumsq_recalc+1; i <= fft1_last_point; i++)
  {
  fft1_slowsum[i]+=fft1_sumsq[pa+i]-fft1_sumsq[pb+i];
  if(fft1_slowsum[i]<0.0000001)fft1_slowsum[i]=0.0000001;
  }
fft1_sumsq_pws=(fft1_sumsq_pws+fft1_size)&fft1_sumsq_mask; 
if(rx_mode != MODE_TXTEST)
  {
  if( ((fft1_sumsq_pws-fft1_sumsq_pwsref+fft1_sumsq_bufsize)&
                   fft1_sumsq_mask) >= (1+((4+wg_fft_avg2num)>>3))*fft1_size)
    {
    fft1_sumsq_pwsref=fft1_sumsq_pws;
    sc[SC_SHOW_FFT1]++;
    lir_sem_post(SEM_SCREEN);
    }
  }  
}

void update_wg_waterf(void)
{      
wg_waterf_ptr-=wg_xpixels;
if(wg_waterf_ptr < 0)wg_waterf_ptr+=wg_waterf_size;
wg_waterf_sum_counter=0;
if( wg_waterf_lines != -1)lir_sem_post(SEM_SCREEN);
}

void fft1_waterfall(void)
{
int i,j,k,m,ix;
float der,t1,y,yval;
while(fft1_sumsq_pwg != fft1_sumsq_pa )
  {
  j=fft1_sumsq_pwg+wg.first_xpoint; 
  for(i=wg_first_point; i <= wg_last_point; i++)
    {
    wg_waterf_sum[i]+=fft1_sumsq[j];
    j++;
    }
  fft1_sumsq_pwg=(fft1_sumsq_pwg+fft1_size)&fft1_sumsq_mask; 
  wg_waterf_sum_counter+=wg.fft_avg1num;
  if(wg_waterf_sum_counter >= wg.waterfall_avgnum)
    {
// A new summed power spectrum has arrived.
// Convert it from linear power scale to log in units of 0.1dB.
// Expand or contract so we get the number of pixels that
// will fit on the screen.
// Store at the pos of our current line in waterfall
    if(wg.xpoints_per_pixel == 1 || wg.pixels_per_xpoint == 1)
      {
      i=wg.first_xpoint;
      for(ix=0; ix < wg_xpixels; ix++)
        {
        y=100*log10(wg_waterf_sum[i]*wg_waterf_yfac[i]);
        if(y < -32767)y=-32767;
        if(y>32767)y=32767;
        wg_waterf[wg_waterf_ptr+ix]=y;
        i++;
        }
      }    
    else
      {
      if(wg.xpoints_per_pixel == 0)
        {
// There are more pixels than data points so we must interpolate.
        y=100*log10(wg_waterf_sum[wg.first_xpoint]*
                                           wg_waterf_yfac[wg.first_xpoint]);
        yval=y;
        if(y < -32767)y=-32767;
        if(y>32767)y=32767;
        wg_waterf[wg_waterf_ptr]=y;
        i=wg.first_xpoint+1;
        m=wg_xpixels-wg.pixels_per_xpoint;
        for(ix=0; ix<m; ix+=wg.pixels_per_xpoint)
          {
          t1=100*log10(wg_waterf_sum[i]*wg_waterf_yfac[i]);
          der=(t1-yval)/wg.pixels_per_xpoint;
          for(k=ix+1; k<=ix+wg.pixels_per_xpoint; k++)
            {
            yval=yval+der;
            y=yval;
            if(y < -32767)y=32767;
            if(y>32767)y=32767;
            wg_waterf[wg_waterf_ptr+k]=y;
            }  

          yval=t1;
          i++;
          }      
        }
      else
        {
// There is more than one data point for each pixel.
// Slide a triangular filter across the spectrum to make it
// smoother before resampling.
        i=wg.first_xpoint;
        for(ix=0; ix<wg_xpixels; ix++)
          {
          t1=wg_waterf_sum[i]*wg.xpoints_per_pixel;
          for(k=1; k<wg.xpoints_per_pixel; k++)
            {
            t1+=(wg_waterf_sum[i+k]+wg_waterf_sum[i-k])*
                                      (wg.xpoints_per_pixel-k);
            }
          y=100*log10(t1*wg_waterf_yfac[i+(wg.xpoints_per_pixel>>1)]);
          if(y < -32767)y=-32767;
          if(y>32767)y=32767;
          wg_waterf[wg_waterf_ptr+ix]=y;
          i+=wg.xpoints_per_pixel;
          }
        }  
      }
    for(i=wg_first_point; i <= wg_last_point; i++)
      {
// Set a very small value rather than zero to avoid errors
// due to sending zero into the log function.      
      wg_waterf_sum[i]=0.00001;
      }
    update_wg_waterf();      
    }
  }
}

void fft1_b(void)
{
int i, k, m, ia,ib,ic,id;
float t1,t2,t3,t4;
int pc;
if( fft1_px == ((fft1_pa+fft1_block)&fft1_mask) )
  {
  timerr(2," fft1_b() OUTPUT");
  }
if(  (ui.input_mode&IQ_DATA) == 0)
  {
  if(ui.rx_channels==1)
    {
    fft1_reherm_dit_one();
    }
  else  
    {
    fft1_reherm_dit_two();
    }
  }
else 
  {
  if(ui.rx_channels==1)
    {
    fft1_complex_one();
// In direct conversion mode it is not possible to get perfect amplitude
// and phase relations between the two channels in the analog circuitry.
// As a result the signal has a mirror image that can be expected in the
// -40dB region for 1% analog filter components.
// The image is removed by the below section that orthogonalises the
// signal and it's mirror using data obtained in a hardware calibration
// process.
    pc=fft1_pa/2;
    m=fft1_first_sym_point;
    if(m==0)m=1;
    ib=pc+m;
    ic=pc+fft1_size-m;
    id=fft1_size-m;
    k=fft1_size/2;
    if(fft1_direction > 0)
      {
      for(ia=m; ia < k; ia++)
        {
        t1=   fft1_float[2*ib  ] * fft1_foldcorr[2*ia  ] 
            - fft1_float[2*ib+1] * fft1_foldcorr[2*ia+1];
        t2=   fft1_float[2*ib  ] * fft1_foldcorr[2*ia+1]
            + fft1_float[2*ib+1] * fft1_foldcorr[2*ia  ];
        fft1_float[2*ib  ] -=   fft1_float[2*ic  ] * fft1_foldcorr[2*id  ] 
                              + fft1_float[2*ic+1] * fft1_foldcorr[2*id+1];
        fft1_float[2*ib+1] -=   fft1_float[2*ic  ] * fft1_foldcorr[2*id+1] 
                              - fft1_float[2*ic+1] * fft1_foldcorr[2*id  ];
        fft1_float[2*ic  ]-=t1;
        fft1_float[2*ic+1]+=t2;
        ib++;
        id--;
        ic--;
        }
      }
    else        
      {
      for(ia=m; ia < k; ia++)
        {
        t1= fft1_float[2*ic  ] -
            fft1_float[2*ib  ] * fft1_foldcorr[2*ia  ] +
            fft1_float[2*ib+1] * fft1_foldcorr[2*ia+1];
        t2= fft1_float[2*ic+1] +
            fft1_float[2*ib  ] * fft1_foldcorr[2*ia+1] +
            fft1_float[2*ib+1] * fft1_foldcorr[2*ia  ];
        t3= fft1_float[2*ib  ] -
            fft1_float[2*ic  ] * fft1_foldcorr[2*id  ] - 
            fft1_float[2*ic+1] * fft1_foldcorr[2*id+1];
        t4= fft1_float[2*ib+1] -
            fft1_float[2*ic  ] * fft1_foldcorr[2*id+1] +
            fft1_float[2*ic+1] * fft1_foldcorr[2*id  ];
        fft1_float[2*ib+1]=t1;
        fft1_float[2*ib  ]=t2;
        fft1_float[2*ic+1]=t3;
        fft1_float[2*ic  ]=t4;
        ib++;
        id--;
        ic--;
        }
      }
    }
  else
    {
    fft1_complex_two();
// In direct conversion mode it is not possible to get perfect amplitude
// and phase relations between the two channels in the analog circuitry.
// As a result the signal has a mirror image that can be expected in the
// -40dB region for 1% analog filter components.
// The image is removed by the below section that orthogonalises the
// signal and it's mirror using data obtained in a hardware calibration
// process.
    pc=fft1_pa/4;
    m=fft1_first_sym_point;
    if(m==0)m=1;
    ib=pc+m;
    ic=pc+fft1_size-m;
    id=fft1_size-m;
    k=fft1_size/2;
    if(fft1_direction > 0)
      {
      for(ia=m; ia < k; ia++)
        {
        t1=   fft1_float[4*ib  ] * fft1_foldcorr[4*ia  ] 
            - fft1_float[4*ib+1] * fft1_foldcorr[4*ia+1];
        t2=   fft1_float[4*ib  ] * fft1_foldcorr[4*ia+1]
            + fft1_float[4*ib+1] * fft1_foldcorr[4*ia  ];
        fft1_float[4*ib  ] -=   fft1_float[4*ic  ] * fft1_foldcorr[4*id  ] 
                              + fft1_float[4*ic+1] * fft1_foldcorr[4*id+1];
        fft1_float[4*ib+1] -=   fft1_float[4*ic  ] * fft1_foldcorr[4*id+1] 
                              - fft1_float[4*ic+1] * fft1_foldcorr[4*id  ];
        fft1_float[4*ic  ]-=t1;
        fft1_float[4*ic+1]+=t2;
        t1=   fft1_float[4*ib+2] * fft1_foldcorr[4*ia+2] 
            - fft1_float[4*ib+3] * fft1_foldcorr[4*ia+3];
        t2=   fft1_float[4*ib+2] * fft1_foldcorr[4*ia+3]
            + fft1_float[4*ib+3] * fft1_foldcorr[4*ia+2];
        fft1_float[4*ib+2] -=   fft1_float[4*ic+2] * fft1_foldcorr[4*id+2] 
                              + fft1_float[4*ic+3] * fft1_foldcorr[4*id+3];
        fft1_float[4*ib+3] -=   fft1_float[4*ic+2] * fft1_foldcorr[4*id+3] 
                              - fft1_float[4*ic+3] * fft1_foldcorr[4*id+2];
        fft1_float[4*ic+2]-=t1;
        fft1_float[4*ic+3]+=t2;
        ib++;
        id--;
        ic--;
        }
      }
    else
      {
      for(ia=m; ia < k; ia++)
        {
        t1= fft1_float[4*ic  ] -
            fft1_float[4*ib  ] * fft1_foldcorr[4*ia  ] +
            fft1_float[4*ib+1] * fft1_foldcorr[4*ia+1];
        t2= fft1_float[4*ic+1] +
            fft1_float[4*ib  ] * fft1_foldcorr[4*ia+1] +
            fft1_float[4*ib+1] * fft1_foldcorr[4*ia  ];
        t3= fft1_float[4*ib  ] -
            fft1_float[4*ic  ] * fft1_foldcorr[4*id  ] - 
            fft1_float[4*ic+1] * fft1_foldcorr[4*id+1];
        t4= fft1_float[4*ib+1] -
            fft1_float[4*ic  ] * fft1_foldcorr[4*id+1] +
            fft1_float[4*ic+1] * fft1_foldcorr[4*id  ];
        fft1_float[4*ib+1]=t1;
        fft1_float[4*ib  ]=t2;
        fft1_float[4*ic+1]=t3;
        fft1_float[4*ic  ]=t4;
        t1= fft1_float[4*ic+2] -
            fft1_float[4*ib+2] * fft1_foldcorr[4*ia+2] +
            fft1_float[4*ib+3] * fft1_foldcorr[4*ia+3];
        t2= fft1_float[4*ic+3] +
            fft1_float[4*ib+2] * fft1_foldcorr[4*ia+3] +
            fft1_float[4*ib+3] * fft1_foldcorr[4*ia+2];
        t3= fft1_float[4*ib+2] -
            fft1_float[4*ic+2] * fft1_foldcorr[4*id+2] - 
            fft1_float[4*ic+3] * fft1_foldcorr[4*id+3];
        t4= fft1_float[4*ib+3] -
            fft1_float[4*ic+2] * fft1_foldcorr[4*id+3] +
            fft1_float[4*ic+3] * fft1_foldcorr[4*id+2];
        fft1_float[4*ib+3]=t1;
        fft1_float[4*ib+2]=t2;
        fft1_float[4*ic+3]=t3;
        fft1_float[4*ic+2]=t4;
        ib++;
        id--;
        ic--;
        }
      }
    }
  }
timf1p_px=(timf1p_px+timf1_blockbytes)&timf1_bytemask;
if(network_flag == 1)
  {
  if(network_modeno == 2)
    {
    i=0;
    if(fg.passband_center != old_passband_center)i=-1;
    write(network_sockfd, &i, sizeof(int));
    if(i != 0)
      {
      write(network_sockfd,&fg.passband_center,sizeof(double));
      write(network_sockfd,&fg.passband_direction,sizeof(int));
      old_passband_center=fg.passband_center;
      }
    write(network_sockfd, &fft1_float[fft1_pa], fft1_block*sizeof(float));
    }
  }  
for(i=0; i<fft1_block; i++)if(fft1_float[i+fft1_pa] !=0)fft1_float[i+fft1_pa]+=.001;


fft1_pa=(fft1_pa+fft1_block)&fft1_mask;  
fft1_na=fft1_pa/fft1_block;
if(fft1_nm != fft1n_mask)fft1_nm++;
}

void fft1_c(void)
{
int ia, ib, ic, pa, ix;
float *pwr;
TWOCHAN_POWER_FLOAT *pxy;
float t1,t2;
// The total filter chain of the hardware, including the IIR filter of
// the approximate real to complex conversion if used is normally not
// very flat, nor has it a good pulse response.
// Add one extra filter here so the total filter response becomes what
// the user has asked for.
// At the same time the data becomes normalised to an amplitude that
// is independent of the processes up to this point.
// Normalisation is for the noise floor to be around 0dB in the
// full dynamic range graph. 
// To save memory accesses, calculate fft1_sumsq at the same time.
// In case AFC is run from fft1 we are probably using a slow 
// computer and large fft1 sizes. Then summed powers are
// calculated elsewhere.

pa=fft1_nb*fft1_block;
ix=fft1_last_point;
ic=fft1_sumsq_pa+fft1_first_point;
if(fft1afc_flag <= 0)
  {
// We want fft1_sumsq to contain summed power spectra calculated from fft1
// over wg.fft_avg1num individual spectra.
  if(fft1_sumsq_counter == 0)
    {
    if(sw_onechan)
      {
      ib=pa/2+fft1_first_point;
      for(ia=fft1_first_point; ia <= ix; ia++)
        {
        t1=fft1_float[2*ib  ]*fft1_filtercorr[2*ia  ]-
           fft1_float[2*ib+1]*fft1_filtercorr[2*ia+1];
        fft1_float[2*ib+1]=fft1_float[2*ib+1]*fft1_filtercorr[2*ia  ]+
                           fft1_float[2*ib  ]*fft1_filtercorr[2*ia+1];
        fft1_float[2*ib]=t1;
        fft1_sumsq[ic]=t1*t1+fft1_float[2*ib+1]*fft1_float[2*ib+1];
        ib++;
        ic++;
        }
      }  
    else
      {
      ib=pa/4+fft1_first_point;
      for(ia=fft1_first_point; ia <= ix; ia++)
        {
        t1=fft1_float[4*ib  ]*fft1_filtercorr[4*ia  ]-
           fft1_float[4*ib+1]*fft1_filtercorr[4*ia+1];
        fft1_float[4*ib+1]=fft1_float[4*ib+1]*fft1_filtercorr[4*ia  ]+
                           fft1_float[4*ib  ]*fft1_filtercorr[4*ia+1];
        fft1_float[4*ib  ]=t1;
        t1=t1*t1+fft1_float[4*ib+1]*fft1_float[4*ib+1];
        t2=fft1_float[4*ib+2]*fft1_filtercorr[4*ia+2]-
           fft1_float[4*ib+3]*fft1_filtercorr[4*ia+3];
        fft1_float[4*ib+3]=fft1_float[4*ib+3]*fft1_filtercorr[4*ia+2]+
                           fft1_float[4*ib+2]*fft1_filtercorr[4*ia+3];
        fft1_float[4*ib+2]=t2;
        fft1_sumsq[ic]=t1+t2*t2+fft1_float[4*ib+3]*fft1_float[4*ib+3];
        ib++;
        ic++;
        }
      }    
    }
  else
    {
    if(sw_onechan)
      {
      ib=pa/2+fft1_first_point;
      for(ia=fft1_first_point; ia <= ix; ia++)
        {
        t1=fft1_float[2*ib  ]*fft1_filtercorr[2*ia  ]-
           fft1_float[2*ib+1]*fft1_filtercorr[2*ia+1];
        fft1_float[2*ib+1]=fft1_float[2*ib+1]*fft1_filtercorr[2*ia  ]+
                           fft1_float[2*ib  ]*fft1_filtercorr[2*ia+1];
        fft1_float[2*ib]=t1;
        fft1_sumsq[ic]+=t1*t1+fft1_float[2*ib+1]*fft1_float[2*ib+1];
        ib++;
        ic++;
        }
      }  
    else
      {
      ib=pa/4+fft1_first_point;
      for(ia=fft1_first_point; ia <= ix; ia++)
        {
        t1=fft1_float[4*ib  ]*fft1_filtercorr[4*ia  ]-
           fft1_float[4*ib+1]*fft1_filtercorr[4*ia+1];
        fft1_float[4*ib+1]=fft1_float[4*ib+1]*fft1_filtercorr[4*ia  ]+
                           fft1_float[4*ib  ]*fft1_filtercorr[4*ia+1];
        fft1_float[4*ib  ]=t1;
        t1=t1*t1+fft1_float[4*ib+1]*fft1_float[4*ib+1];               
        t2=fft1_float[4*ib+2]*fft1_filtercorr[4*ia+2]-
           fft1_float[4*ib+3]*fft1_filtercorr[4*ia+3];
        fft1_float[4*ib+3]=fft1_float[4*ib+3]*fft1_filtercorr[4*ia+2]+
                           fft1_float[4*ib+2]*fft1_filtercorr[4*ia+3];
        fft1_float[4*ib+2]=t2;
        fft1_sumsq[ic]+=t1+t2*t2+fft1_float[4*ib+3]*fft1_float[4*ib+3];
        ib++;
        ic++;
        }
      }    
    }
  }    
else
  {
// This code is executed to make the last step of fft1 in case
// fft2 is not selected and AFC is in use.
  if(no_of_spurs > 0)  
    {
    if(sw_onechan)
      {
      ib=pa/2+fft1_first_point;
      for(ia=fft1_first_point; ia <= ix; ia++)
        {
        t1=fft1_float[2*ib  ]*fft1_filtercorr[2*ia  ]-
           fft1_float[2*ib+1]*fft1_filtercorr[2*ia+1];
        fft1_float[2*ib+1]=fft1_float[2*ib+1]*fft1_filtercorr[2*ia  ]+
                           fft1_float[2*ib  ]*fft1_filtercorr[2*ia+1];
        fft1_float[2*ib]=t1;
        ib++;
        }
      }  
    else
      {
      ib=pa/4+fft1_first_point;
      for(ia=fft1_first_point; ia <= ix; ia++)
        {
        t1=fft1_float[4*ib  ]*fft1_filtercorr[4*ia  ]-
           fft1_float[4*ib+1]*fft1_filtercorr[4*ia+1];
        fft1_float[4*ib+1]=fft1_float[4*ib+1]*fft1_filtercorr[4*ia  ]+
                           fft1_float[4*ib  ]*fft1_filtercorr[4*ia+1];
        fft1_float[4*ib  ]=t1;
        t2=fft1_float[4*ib+2]*fft1_filtercorr[4*ia+2]-
           fft1_float[4*ib+3]*fft1_filtercorr[4*ia+3];
        fft1_float[4*ib+3]=fft1_float[4*ib+3]*fft1_filtercorr[4*ia+2]+
                           fft1_float[4*ib+2]*fft1_filtercorr[4*ia+3];
        fft1_float[4*ib+2]=t2;
        ib++;
        }
      }    
    fftx_na=fft1_nb;
    eliminate_spurs();
    if(fft1_sumsq_counter == 0)
      {
      if(sw_onechan)
        {
        ib=pa/2+fft1_first_point;
        pwr=&fft1_power[fft1_nb*fft1_size];
        for(ia=fft1_first_point; ia <= ix; ia++)
          {
          pwr[ia]=fft1_float[2*ib]*fft1_float[2*ib]+
                  fft1_float[2*ib+1]*fft1_float[2*ib+1];
          fft1_sumsq[ic]=pwr[ia];
          ib++;
          ic++;
          }
        }  
      else
        {
        ib=pa/4+fft1_first_point;
        pxy=&fft1_xypower[fft1_nb*fft1_size];
        for(ia=fft1_first_point; ia <= ix; ia++)
          {
          pxy[ia].x2=fft1_float[4*ib  ]*fft1_float[4*ib  ]+
                     fft1_float[4*ib+1]*fft1_float[4*ib+1];
          pxy[ia].y2=fft1_float[4*ib+2]*fft1_float[4*ib+2]+
                     fft1_float[4*ib+3]*fft1_float[4*ib+3];
          pxy[ia].im_xy=-fft1_float[4*ib  ]*fft1_float[4*ib+3]+
                         fft1_float[4*ib+2]*fft1_float[4*ib+1];
          pxy[ia].re_xy= fft1_float[4*ib  ]*fft1_float[4*ib+2]+
                         fft1_float[4*ib+1]*fft1_float[4*ib+3];
          fft1_sumsq[ic]=pxy[ia].x2+pxy[ia].y2;
          ic++;
          ib++;
          }
        }    
      }
    else
      {
      if(sw_onechan)
        {
        ib=pa/2+fft1_first_point;
        pwr=&fft1_power[fft1_nb*fft1_size];
        for(ia=fft1_first_point; ia <= ix; ia++)
          {
          pwr[ia]=fft1_float[2*ib]*fft1_float[2*ib]+
                  fft1_float[2*ib+1]*fft1_float[2*ib+1];
          fft1_sumsq[ic]+=pwr[ia];
          ic++;
          ib++;
          }
        }  
      else
        {
        ib=pa/4+fft1_first_point;
        pxy=&fft1_xypower[fft1_nb*fft1_size];
        for(ia=fft1_first_point; ia <= ix; ia++)
          {
          pxy[ia].x2=fft1_float[4*ib  ]*fft1_float[4*ib  ]+
                     fft1_float[4*ib+1]*fft1_float[4*ib+1];
          pxy[ia].y2=fft1_float[4*ib+2]*fft1_float[4*ib+2]+
                     fft1_float[4*ib+3]*fft1_float[4*ib+3];
          pxy[ia].im_xy=-fft1_float[4*ib  ]*fft1_float[4*ib+3]+
                         fft1_float[4*ib+2]*fft1_float[4*ib+1];
          pxy[ia].re_xy= fft1_float[4*ib  ]*fft1_float[4*ib+2]+
                         fft1_float[4*ib+1]*fft1_float[4*ib+3];
          fft1_sumsq[ic]+=pxy[ia].x2+pxy[ia].y2;
          ic++;
          ib++;
          }
        }    
      }
    }  
  else
    {    
    if(fft1_sumsq_counter == 0)
      {
      if(sw_onechan)
        {
        ib=pa/2+fft1_first_point;
        pwr=&fft1_power[fft1_nb*fft1_size];
        for(ia=fft1_first_point; ia <= ix; ia++)
          {
          t1=fft1_float[2*ib  ]*fft1_filtercorr[2*ia  ]-
             fft1_float[2*ib+1]*fft1_filtercorr[2*ia+1];
          fft1_float[2*ib+1]=fft1_float[2*ib+1]*fft1_filtercorr[2*ia  ]+
                             fft1_float[2*ib  ]*fft1_filtercorr[2*ia+1];
          fft1_float[2*ib]=t1;
          pwr[ia]=t1*t1+fft1_float[2*ib+1]*fft1_float[2*ib+1];
          fft1_sumsq[ic]=pwr[ia];
          ib++;
          ic++;
          }
        }  
      else
        {
        ib=pa/4+fft1_first_point;
        pxy=&fft1_xypower[fft1_nb*fft1_size];
        for(ia=fft1_first_point; ia <= ix; ia++)
          {
          t1=fft1_float[4*ib  ]*fft1_filtercorr[4*ia  ]-
             fft1_float[4*ib+1]*fft1_filtercorr[4*ia+1];
          fft1_float[4*ib+1]=fft1_float[4*ib+1]*fft1_filtercorr[4*ia  ]+
                             fft1_float[4*ib  ]*fft1_filtercorr[4*ia+1];
          fft1_float[4*ib  ]=t1;
          t2=fft1_float[4*ib+2]*fft1_filtercorr[4*ia+2]-
             fft1_float[4*ib+3]*fft1_filtercorr[4*ia+3];
          fft1_float[4*ib+3]=fft1_float[4*ib+3]*fft1_filtercorr[4*ia+2]+
                             fft1_float[4*ib+2]*fft1_filtercorr[4*ia+3];
          fft1_float[4*ib+2]=t2;
          pxy[ia].x2=t1*t1+fft1_float[4*ib+1]*fft1_float[4*ib+1];
          pxy[ia].y2=t2*t2+fft1_float[4*ib+3]*fft1_float[4*ib+3];
          pxy[ia].im_xy=-t1*fft1_float[4*ib+3]+t2*fft1_float[4*ib+1];
          pxy[ia].re_xy=t1*t2+fft1_float[4*ib+1]*fft1_float[4*ib+3];
          fft1_sumsq[ic]=pxy[ia].x2+pxy[ia].y2;
          ic++;
          ib++;
          }
        }    
      }
    else
      {
      if(sw_onechan)
        {
        ib=pa/2+fft1_first_point;
        pwr=&fft1_power[fft1_nb*fft1_size];
        for(ia=fft1_first_point; ia <= ix; ia++)
          {
          t1=fft1_float[2*ib  ]*fft1_filtercorr[2*ia  ]-
             fft1_float[2*ib+1]*fft1_filtercorr[2*ia+1];
          fft1_float[2*ib+1]=fft1_float[2*ib+1]*fft1_filtercorr[2*ia  ]+
                             fft1_float[2*ib  ]*fft1_filtercorr[2*ia+1];
          fft1_float[2*ib]=t1;
          pwr[ia]=t1*t1+fft1_float[2*ib+1]*fft1_float[2*ib+1];
          fft1_sumsq[ic]+=pwr[ia];
          ic++;
          ib++;
          }
        }  
      else
        {
        ib=pa/4+fft1_first_point;
        pxy=&fft1_xypower[fft1_nb*fft1_size];
        for(ia=fft1_first_point; ia <= ix; ia++)
          {
          t1=fft1_float[4*ib  ]*fft1_filtercorr[4*ia  ]-
             fft1_float[4*ib+1]*fft1_filtercorr[4*ia+1];
          fft1_float[4*ib+1]=fft1_float[4*ib+1]*fft1_filtercorr[4*ia  ]+
                             fft1_float[4*ib  ]*fft1_filtercorr[4*ia+1];
          fft1_float[4*ib  ]=t1;
          t2=fft1_float[4*ib+2]*fft1_filtercorr[4*ia+2]-
             fft1_float[4*ib+3]*fft1_filtercorr[4*ia+3];
          fft1_float[4*ib+3]=fft1_float[4*ib+3]*fft1_filtercorr[4*ia+2]+
                             fft1_float[4*ib+2]*fft1_filtercorr[4*ia+3];
          fft1_float[4*ib+2]=t2;
          pxy[ia].x2=t1*t1+fft1_float[4*ib+1]*fft1_float[4*ib+1];
          pxy[ia].y2=t2*t2+fft1_float[4*ib+3]*fft1_float[4*ib+3];
          pxy[ia].im_xy=-t1*fft1_float[4*ib+3]+t2*fft1_float[4*ib+1];
          pxy[ia].re_xy=t1*t2+fft1_float[4*ib+1]*fft1_float[4*ib+3];
          fft1_sumsq[ic]+=pxy[ia].x2+pxy[ia].y2;
          ic++;
          ib++;
          }
        }    
      }
    }
  }
fft1_sumsq_counter++;
if(fft1_sumsq_counter >= wg.fft_avg1num)
  {
  fft1_sumsq_counter=0;
// We have a new average power spectrum.
// In case the second fft is enabled we have to set up information
// for the selective limiter.
  if(genparm[SECOND_FFT_ENABLE] != 0)
    {
    fft1_update_liminfo();
    }
  fft1_sumsq_pa=(fft1_sumsq_pa+fft1_size)&fft1_sumsq_mask;   
  }
fft1_nb=(fft1_nb+1)&fft1n_mask;
fft1_pb=fft1_nb*fft1_block;
if(genparm[SECOND_FFT_ENABLE] == 0)ag_pa=(ag_pa+1)&ag_mask;  
}

void set_fft1_endpoints(void)
{
// Set all pointers for a non-inverted spectrum.
wg_first_point=wg.first_xpoint;
wg_last_point=wg.first_xpoint+wg.xpoints-1;

fft1_first_point=0;
fft1_last_point=fft1_size-1;
fft1_first_inband=fft1_first_point;
fft1_last_inband=fft1_last_point;
if(network_flag == 0)
  { 
  if(genparm[SECOND_FFT_ENABLE] == 0)
    {
// In case second fft is not enabled, there is no reason to calculate
// the spectrum outside the range that we use on the display.
    fft1_first_point=wg_first_point;
    fft1_last_point=wg_last_point;
    }
  else
    {
    while(fft1_desired[fft1_first_point]<0.00001 && 
                            fft1_first_point<fft1_size-1)fft1_first_point++;
    fft1_first_inband=fft1_first_point;
    while(fft1_desired[fft1_first_inband]<0.5 && 
                          fft1_first_inband<fft1_size-1) fft1_first_inband++;
    while(fft1_desired[fft1_last_point]<0.00001 && 
                                       fft1_last_point > 0) fft1_last_point--;
    fft1_last_inband=fft1_last_point;
    while(fft1_desired[fft1_last_inband]<0.5 && 
                           fft1_last_inband > 0) fft1_last_inband--;
    if(fft1_last_point-fft1_first_point<fft1_size/16)lirerr(1057);
    if(fft1_last_inband-fft1_first_inband<fft1_size/32)lirerr(1057);
    }
  }  
fft1_sumsq_recalc=fft1_first_point;
fft1_first_sym_point=fft1_size-1-fft1_last_point;
if(fft1_first_sym_point > fft1_first_point) 
                                     fft1_first_sym_point=fft1_first_point;
fft1_last_sym_point=fft1_size-1-fft1_first_sym_point;
}

void make_filcorrstart(void)
{
fft1_filtercorr_start=150*fft1_size*pow((float)(fft1_size),-0.4);
if( (ui.input_mode&DWORD_INPUT) != 0)
  {
  fft1_filtercorr_start*=4096;
  if( fft_cntrl[FFT1_CURMODE].permute == 2)fft1_filtercorr_start*=16;
  if( (ui.input_mode&IQ_DATA) != 0)
    {
    fft1_filtercorr_start*=12;
    }
  }
fft1_filtercorr_start=genparm[FIRST_FFT_GAIN]/fft1_filtercorr_start;
}

void clear_fft1_filtercorr(void)
{
float t1, t2, t3;
int i, j, k, mm;
settextcolor(8);
for(i=3; i<20; i++)lir_text(40,i,"FILTERS NOT CALIBRATED!!");
fft1_filtercorr_flag=0;
make_filcorrstart();
settextcolor(7);
mm=twice_rxchan;
for(i=0; i<fft1_size; i++)
  {
  fft1_desired[i]=1;
  for(j=0; j<mm; j+=2)  
    {
    fft1_filtercorr[mm*i+j  ]=fft1_filtercorr_start;
    fft1_filtercorr[mm*i+j+1]=0;
    }
  }  
// A DC offset on the A/D converters cause signals
// at frequency=0 and at frequency=fft1_size/2. 
// These frequencies are not properly separated
// by the backwards fft in case a window N other
// than 0 or 2 is used.
// Signals very close to the Nyquist frequency
// are artifacts anyway so we set the desired response
// to filter them out.
  {     
  t1=0.125*PI_L;
  t2=-.25*PI_L;
  i=0;
  k=fft1_size-1;
  while(t2 < 0.5*PI_L)
    {
    t3=pow(sin(t2),2);
    if(t2<0)t3=0;
    fft1_desired[i]=t3;
    for(j=0; j<mm; j+=2)fft1_filtercorr[mm*i+j  ]=t3*fft1_filtercorr_start;
    fft1_desired[k]=t3;
    for(j=0; j<mm; j+=2)fft1_filtercorr[mm*k+j  ]=t3*fft1_filtercorr_start;
    t2+=t1;
    i++;
    k--;
    }
  }  
}

void expand_fft1_filtercorr(int cal_n, int cal_size)
{
int i, j, k, m, mm;
float t1,t2;
COSIN_TABLE *small_ffttab, *big_ffttab; 
unsigned short int *small_permute,*big_permute;
// FFT size is increased.
// Get the fourier transform with the old number of points.
// Increase the number of points and fill zeroes at high frequencies 
// in the transform.
// Then take the back transform to get function in fft1_size points.    
mm=twice_rxchan;
small_ffttab=malloc(cal_size*sizeof(COSIN_TABLE )/2);
small_permute=malloc(cal_size*sizeof(short int));
big_ffttab=malloc(fft1_size*sizeof(COSIN_TABLE )/2);
big_permute=malloc(fft1_size*sizeof(short int));
if( small_ffttab == NULL ||
    small_permute == NULL ||
    big_ffttab == NULL ||
    big_permute == NULL)
  {
  lirerr(1055);
  return;
  }
init_fft(0,fft1_n, fft1_size, big_ffttab, big_permute);
init_fft(0,cal_n, cal_size, small_ffttab, small_permute);
for(j=0; j<mm; j+=2)
  {
  for(i=0; i<cal_size; i++)
    {
    fftw_tmp[2*i  ]=fft1_filtercorr[mm*i+j  ];
    fftw_tmp[2*i+1]=fft1_filtercorr[mm*i+j+1];
    }
  fftback(cal_size, cal_n, fftw_tmp, small_ffttab, small_permute);
  for(i=cal_size/2; i<cal_size; i++)
    {
    k=i+fft1_size-cal_size;
    fftw_tmp[2*k  ]=fftw_tmp[2*i  ];
    fftw_tmp[2*k+1]=fftw_tmp[2*i+1];
    }
  for(i=cal_size/2; i<fft1_size-cal_size/2; i++)
    {
    fftw_tmp[2*i  ]=0;
    fftw_tmp[2*i+1]=0;
    }
  fftforward(fft1_size, fft1_n, fftw_tmp, big_ffttab, big_permute);
  m=fft1_size>>(fft1_n-cal_n-1);
  for(i=0; i<fft1_size; i++)
    {
    fft1_filtercorr[mm*i+j  ]=fftw_tmp[2*i]/m;
    fft1_filtercorr[mm*i+j+1]=fftw_tmp[2*i+1]/m;
    }
  }
m=fft1_size/cal_size;    
for(j=cal_size-1; j>0; j--)
  {
  t1=fft1_desired[j];
  t2=fft1_desired[j-1];
  for(i=0; i<m; i++)
    {
    fft1_desired[m*j-i]=t1+i*(t2-t1)/m;
    }
  }
fft1_desired[0]=0;
free(small_ffttab);
free(small_permute);
free(big_ffttab);
free(big_permute);
}


void init_fft1_filtercorr(void)
{
COSIN_TABLE *big_ffttab; 
unsigned short int *big_permute;
int rdbuf[10],chkbuf[10];
int i, j, k, m, mm;
int mask, ia, ib;
float t1,t2;
FILE *file;
char s[80];
double sum[4],isum[4];
fft1_filtercorr_direction=1;
fft1_filtercorr_flag=1;
mm=twice_rxchan;
make_filfunc_filename(s);
if(disksave_flag == 2 && (save_init_flag&1) == 1)
  {
  file=save_file;
  }
else
  {
  file = fopen(s, "rb");
  }
if (file == NULL)
  {
  clear_fft1_filtercorr();
  }
else
  {
  fread(rdbuf, sizeof(int),10,file);
  if( rdbuf[2] <0 ||
      rdbuf[2] >= MAX_RX_MODE ||
      (rdbuf[3]&IQ_DATA) != (ui.input_mode&IQ_DATA) ||
      rdbuf[5] != ui.input_speed ||
      rdbuf[6] != ui.rx_channels ||
      rdbuf[8] != 0 ||
      rdbuf[9] != 0 ) 
    {
    if(disksave_flag == 2 && (save_init_flag&1) == 1)
      {
      lirerr(1059);
      return;
      }
    clear_fft1_filtercorr();
    }
  else
    {
    if(rdbuf[7] == 0)
      {
// The filtercorr function is saved in the frequency domain
// This format is used during the initialisation procedures and
// it may be kept for normal operation in case the number of points
// will not be reduced by saving in the time domain.  
      if(rdbuf[1] <= fft1_size)
        {
        fread(fft1_filtercorr, mm*sizeof(float),rdbuf[1], file);
        fread(fft1_desired, sizeof(float),rdbuf[1], file);
        if(10 != fread(chkbuf, sizeof(int),10,file))goto exx;
        for(i=0; i<10; i++)
          {
          if(rdbuf[i]!=chkbuf[i])goto exx;
          }
        if(rdbuf[1] != fft1_size)expand_fft1_filtercorr(rdbuf[0], rdbuf[1]);
        }
      else
        {
        m=1<<(rdbuf[0]-fft1_n);
        for(i=0; i<fft1_size; i++)
          {  
          for(j=0; j<mm; j++)fft1_filtercorr[mm*i+j]=0;
          fread(fft1_float, mm*sizeof(float),m, file);
          for(k=0; k<m; k++)
            {
            for(j=0; j<mm; j++)fft1_filtercorr[mm*i+j]+=fft1_float[k*mm+j];
            }
          for(j=0; j<mm; j++)fft1_filtercorr[mm*i+j]/=m; 
          }
        for(i=0; i<fft1_size; i++)
          {
          fft1_desired[i]=0;  
          fread(fft1_float, sizeof(float),m, file);
          for(k=0; k<m; k++)
            {
            fft1_desired[i]+=fft1_float[k];
            } 
          fft1_desired[i]/=k;  
          }
        if(10 != fread(chkbuf, sizeof(int),10,file))goto exx;
        for(i=0; i<10; i++)
          {
          if(rdbuf[i]!=chkbuf[i])goto exx;
          }
        }
      }
    else
      {
// The correction function was stored in the time domain in rdbuf[7] points
      mm=twice_rxchan;
      if( fft1_size < rdbuf[7])
        {
// We have to reduce the number of points.
        fread(fft1_filtercorr, mm*sizeof(float),fft1_size/2, file);
        for(m=0; m<rdbuf[7]-fft1_size; m++)
                                 fread(&fft1_filtercorr[mm*fft1_size/2], 
                                                    mm*sizeof(float),1, file);
        fread(&fft1_filtercorr[mm*fft1_size/2], 
                                          mm*sizeof(float),fft1_size/2, file);
// When limiting the pulse response in the time domain, we may
// introduce a discontinuity. It will occur between fft1_size/2 and
// fft1/size/2-1.
// Differentiate the pulse response starting at the discontinuity:
        mask=fft1_size-1;
        ia=fft1_size/2;
        ib=ia+1;
        for(i=1; i<fft1_size; i++)
          {
          for(j=0; j<mm; j++)
            {
            fft1_filtercorr[ia*mm+j] = fft1_filtercorr[ia*mm+j]
                                      -fft1_filtercorr[ib*mm+j];
            }
          ia=(ia+1)&mask;
          ib=(ib+1)&mask;
          }  
        for(j=0;j<mm; j++)
          {
          fft1_filtercorr[ia*mm+j]=0;
          sum[j]=0;
          }
// Get the DC component so we can remove it from the derivative
        for(i=0; i<fft1_size; i++)
          {
          for(j=0;j<mm; j++)
            {
            sum[j]+=fft1_filtercorr[i*mm+j];
            }
          }
        for(j=0;j<mm; j++)
          {
          sum[j]/=fft1_size;
          isum[j]=0;
          }
// Integrate the pulse response:
        for(i=0; i<fft1_size; i++)
          {
          for(j=0; j<mm; j++)
            {
            isum[j]+=fft1_filtercorr[ia*mm+j]-sum[j];
            fft1_filtercorr[ia*mm+j]=isum[j];
            }
          ia=(ia+mask)&mask;
          }  
        m=rdbuf[7]/fft1_size;
        i=0;
rrd:;
        for(j=0; j<m/2; j++)fread(&fft1_desired[i], sizeof(float),1, file);
        i++;
        if(i >= fft1_size)
          {
          for(j=m/2; j<m; j++)fread(chkbuf, sizeof(float),1, file);
          goto rrdx;
          }
        for(j=m/2; j<m; j++)fread(&fft1_desired[i], sizeof(float),1, file);
        goto rrd;
rrdx:;         
        }
      else
        {
        
        fread(fft1_filtercorr, mm*sizeof(float),rdbuf[7], file);
        fread(fft1_desired, sizeof(float),rdbuf[7], file);
        }
      if(10 != fread(chkbuf, sizeof(int),10,file))
        {
exx:;          
        if(disksave_flag==2)lirerr(1198); else lirerr(1052);
        return;
        }
      for(i=0; i<10; i++)
        {
        if(rdbuf[i]!=chkbuf[i])goto exx;
        }
      big_ffttab=malloc(fft1_size*sizeof(COSIN_TABLE )/2);
      big_permute=malloc(fft1_size*sizeof(short int));
      if( big_ffttab == NULL || big_permute == NULL)
        {
        lirerr(1055);
        return;
        }
      init_fft(0,fft1_n, fft1_size, big_ffttab, big_permute);
      if(fft1_size > rdbuf[7])
        {
// size is increased.
// We have the fourier transform with rdbuf[7] points.
// Increase the number of points and fill zeroes at high frequencies 
// in the transform.
        for(i=rdbuf[7]/2; i<rdbuf[7]; i++)
          {
          k=i+fft1_size-rdbuf[7];
          for(j=0; j<mm; j++)
            {
            fft1_filtercorr[mm*k+j]=fft1_filtercorr[mm*i+j];
            }
          } 
        for(i=rdbuf[7]/2; i<fft1_size-rdbuf[7]/2; i++)
          {
          for(j=0; j<mm; j++)
            {
            fft1_filtercorr[mm*i+j]=0;
            }
          } 
        m=fft1_size/rdbuf[7];    
        for(j=rdbuf[7]-1; j>0; j--)
          {
          t1=fft1_desired[j];
          t2=fft1_desired[j-1];
          for(i=0; i<m; i++)
            {
            fft1_desired[m*j-i]=t1+i*(t2-t1)/m;
            }
          }
        fft1_desired[0]=0;
        } 
// Take the back transform to get function in fft1_size points
// in the frequency domain.    
      for(j=0; j<mm; j+=2)
        {
        for(i=0; i<fft1_size; i++)
          {
          fftw_tmp[2*i  ]=fft1_filtercorr[mm*i+j  ];
          fftw_tmp[2*i+1]=fft1_filtercorr[mm*i+j+1];
          }
        fftback(fft1_size, fft1_n, fftw_tmp, big_ffttab, big_permute);
        for(i=0; i<fft1_size; i++)
          {
          if(fft1_desired[i] != 0)
            {
            fft1_filtercorr[mm*i+j  ]=fftw_tmp[2*i  ];
            fft1_filtercorr[mm*i+j+1]=fftw_tmp[2*i+1];
            }
          else 
            {
            fft1_filtercorr[mm*i+j  ]=0;
            fft1_filtercorr[mm*i+j+1]=0;
            }
          }
        }
      free(big_ffttab);
      free(big_permute);
      normalise_fft1_filtercorr(fft1_filtercorr);
      }
    if(disksave_flag != 2 || (save_init_flag&1) == 0)
      {
      fclose(file);
      }
    make_filcorrstart();    
    for(i=0; i<twice_rxchan*fft1_size; i++)
      {
      fft1_filtercorr[i]*=fft1_filtercorr_start;
      } 
    }
  }
for(i=0; i<fft1_size; i++)
  {
  wg_waterf_sum[i]=0.00001;
  if(fft1_desired[i]==0)
    {
    for(j=0; j<mm; j+=2)
      {
      fft1_filtercorr[i*mm  ]=0;
      fft1_filtercorr[i*mm+1]=0;
      }  
    }
  }    
}

void clear_iq_foldcorr(void)
{
int i;
for(i=0; i<twice_rxchan*fft1_size; i++)fft1_foldcorr[i]=0;
settextcolor(8);
for(i=3; i<20; i++)lir_text(10,i,"I/Q PHASE NOT CALIBRATED!!");
fft1_calibrate_flag&=1;
settextcolor(7);
bal_updflag=1;
}

void init_foldcorr(void)
{
int rdbuf[10],chkbuf[10];
int ia, i, j, k;
FILE *file;
float t1,t2;
char s[80];
if(  (ui.input_mode&IQ_DATA) == 0)
  {
  if( FOLDCORR_START_SIZE == fft1_size/2)
    {
    for(i=0; i<fft1_size/2; i++)
      {
      fft1_foldcorr[2*i  ]=foldcorr_y1[i];
      fft1_foldcorr[2*i+1]=foldcorr_y2[i];
      }
    }
  else
    {
    if( FOLDCORR_START_SIZE > fft1_size/2)
      {
      k=2*FOLDCORR_START_SIZE/fft1_size;
      j=0;
      for(i=0; i<fft1_size/2; i++)
        {
        fft1_foldcorr[2*i  ]=foldcorr_y1[j];
        fft1_foldcorr[2*i+1]=foldcorr_y2[j];
        j+=k;
        }
      }
    else
      {
// We need to interpolate.
// The foldcorr data is not very accurate anyway so a linear interpolation
// will be enough for the time being.
      k=fft1_size/(2*FOLDCORR_START_SIZE);
      ia=0;
      for(i=1; i<FOLDCORR_START_SIZE; i++)
        {
        fft1_foldcorr[2*ia  ]=foldcorr_y1[i-1];
        fft1_foldcorr[2*ia+1]=foldcorr_y2[i-1];
        t1=(foldcorr_y1[i]-foldcorr_y1[i-1])/k;
        t2=(foldcorr_y2[i]-foldcorr_y2[i-1])/k;
        for(j=1; j<k; j++)
          {
          fft1_foldcorr[2*(ia+j)  ]=fft1_foldcorr[2*(ia+j-1)  ]+t1;          
          fft1_foldcorr[2*(ia+j)+1]=fft1_foldcorr[2*(ia+j-1)+1]+t2;
          }          
        ia+=k;
        }
      }
    }          
  }
else
  {
  if(disksave_flag == 2 && (save_init_flag&2) == 2)
    {
    file=save_file;
    }
  else
    {
    make_iqcorr_filename(s);
    file = fopen(s, "rb");
    }
  if (file == NULL)
    {
    clear_iq_foldcorr();
    }
  else
    {
    fread(rdbuf, sizeof(int),10,file);
    if( rdbuf[1] != (ui.input_mode&IQ_DATA) ||
        rdbuf[2] != ui.input_speed ||
        rdbuf[3] != ui.rx_channels ||
        rdbuf[4] != FOLDCORR_VERNR )
      {
      if(disksave_flag == 2 && (save_init_flag&2) == 2)
        {
        lirerr(1060);
        return;
        }
      clear_iq_foldcorr();
      }
    else  
      {  
      bal_segments=rdbuf[0];
      contracted_iq_foldcorr=fft1_float;
// Note that the file is too large by a factor of 4.
// We better keep compatibility with old code..............
      fread(contracted_iq_foldcorr, twice_rxchan*sizeof(float),
                                                      4*bal_segments, file);  
      if(10 != fread(chkbuf, sizeof(int),10,file))
        {
        lirerr(1053);
        return;
        }
      for(i=0; i<10; i++)
        {
        if(rdbuf[i]!=chkbuf[i])
          {
          lirerr(1053);
          return;
          }
        }
      if(disksave_flag != 2 || (save_init_flag&2) == 0)fclose(file);
      cal_table=malloc(fft1_size*sizeof(COSIN_TABLE )/2);
      cal_permute=malloc(fft1_size*sizeof(short int));
      if( cal_table == NULL || cal_permute == NULL)
        {
        lirerr(1110);
        return;
        }
      init_fft(0,fft1_n, fft1_size, cal_table, cal_permute);
      expand_foldcorr(fft1_foldcorr,fftw_tmp);
      free(cal_table);
      free(cal_permute);
      }
    }
  }
}


