
#include <ctype.h>
#include <unistd.h>
//#include "netdef.h"
#include "globdef.h"
#include "uidef.h"
#include "fft1def.h"
#include "vernr.h"
#include "caldef.h"
#include "screendef.h"
#include "thrdef.h"

unsigned int network_wait(void);
#define NETPAR_FILENAME "par_network"
#define NETPAR_FILESIZE 256
#define NETHEADER_SIZE 6
#define FFT1_INFOSIZ 3
char *netmodes[]={"No network",
                  "A/D raw data", 
                  "First FFT transforms"};


void network_send_fft1info(void)
{
int netdat[FFT1_INFOSIZ];
netdat[0]=genparm[FIRST_FFT_SINPOW];
netdat[1]=genparm[FIRST_FFT_BANDWIDTH];
netdat[2]=genparm[FIRST_FFT_VERNR];
write(network_sockfd,netdat, FFT1_INFOSIZ*sizeof(int));
}

void network_receive_fft1info(void)
{
/*
int netdat[FFT1_INFOSIZ];
unsigned int nread;
ioctl(network_fd, FIONREAD, &nread);
clear_screen();
nread=0;
while(nread < FFT1_INFOSIZ*sizeof(int))
  {
  nread=network_wait();
  IFEXIT return;
  }
clear_screen();
read(network_fd, netdat, FFT1_INFOSIZ*sizeof(int));
genparm[FIRST_FFT_SINPOW]=netdat[0];
genparm[FIRST_FFT_BANDWIDTH]=netdat[1];
genparm[FIRST_FFT_VERNR]=netdat[2];
fg.passband_center=0;
fg.passband_direction=1;
//????????check_filtercorr_direction();
*/
}


void network_send_adinfo(void)
{
write(network_sockfd,&fft1_size, sizeof(int));
write(network_sockfd,&fft1_n, sizeof(int));
write(network_sockfd,fft1_filtercorr, fft1_size*twice_rxchan*sizeof(float));
write(network_sockfd,fft1_desired, fft1_size*sizeof(float));
write(network_sockfd,fft1_foldcorr, foldcorr_bytes);
lir_sleep(100000);
}


int network_nread; 
void net_read( char *buf, int bytes)
{
int nread, rdbytes;
rdbytes=0;
while(rdbytes < bytes)
  {
  nread=network_nread;
  if(nread > 0)
    {
    if(nread > bytes+rdbytes)nread=bytes-rdbytes;
    read(network_fd, &buf[rdbytes], nread);
    rdbytes+=nread;
    network_nread-=nread;
    }
  else
    {
    network_nread=network_wait();
    } 
  }
}

void network_receive_adinfo(void)
{
/*
int i, j, m, mm, cal_size, cal_n;
int foldcorr_size, fobytes;
ioctl(network_fd, FIONREAD, &network_nread);
mm=2*ui.rx_channels;
clear_screen();
net_read( (char*)&cal_size, sizeof(int));
net_read( (char*)&cal_n, sizeof(int));
if( (ui.input_mode&IQ_DATA) == 0)
  {
  fobytes=cal_size;
  }
else
  {
  fobytes=mm*cal_size;
  }
fobytes*=sizeof(float);
clear_screen();
if(cal_size < fft1_size)
  {
  net_read((char*)fft1_filtercorr, cal_size*mm*sizeof(float));
  net_read((char*)fft1_desired, cal_size*sizeof(float));
  contracted_iq_foldcorr=malloc(fobytes+16);
  if(contracted_iq_foldcorr == NULL)
    {
    lirerr(1049);
    return;
    }
  net_read((char*)contracted_iq_foldcorr, fobytes);
  expand_fft1_filtercorr( cal_n, cal_size);
  bal_segments=cal_size/4;
  if( (ui.input_mode&IQ_DATA) != 0)
    {
    cal_table=malloc(fft1_size*sizeof(COSIN_TABLE )/2);
    if(cal_table == NULL)
      {
err1110:;      
      lirerr(1110);
      return;
      }
    cal_permute=malloc(fft1_size*sizeof(short int));
    if(cal_permute == NULL)goto err1110;
    init_fft(0,fft1_n, fft1_size, cal_table, cal_permute);
    expand_foldcorr(fft1_foldcorr,fftw_tmp);
    free(cal_table);
    free(cal_permute);
    }
  else
    {
    init_foldcorr();
    }
  free(contracted_iq_foldcorr);
  }
else
  {
  m=1<<(cal_n-fft1_n);
  for(i=0; i<fft1_size; i++)
    {  
    net_read((char*)fft1_float, m*mm*sizeof(float));
    for(j=0; j<mm; j++)fft1_filtercorr[mm*i+j]=fft1_float[j];
    }  
  for(i=0; i<fft1_size; i++)
    {  
    net_read((char*)fft1_float, m*sizeof(float));
    fft1_desired[i]=fft1_float[0];
    }  
  if( (ui.input_mode&IQ_DATA) != 0)
    {
    foldcorr_size=fft1_size;
    }
  else
    {
    foldcorr_size=fft1_size/2;
    mm=2;
    }
  for(i=0; i<foldcorr_size; i++)
    {  
    net_read((char*)fft1_float, m*mm*sizeof(float));
    for(j=0; j<mm; j++)fft1_foldcorr[mm*i+j]=fft1_float[j];
    }  
  }  
if( (ui.input_mode&IQ_DATA) == 0)
  {
  init_foldcorr();
  }
normalise_fft1_filtercorr(fft1_filtercorr);
make_filcorrstart();    
for(i=0; i<twice_rxchan*fft1_size; i++)
  {
  fft1_filtercorr[i]*=fft1_filtercorr_start;
  } 
for(i=0; i<fft1_size; i++)
  {
  fft1_filtercorr[2*i]=fft1_filtercorr_start;
  fft1_filtercorr[2*i+1]=0;
  fft1_desired[i]=1;
  }
fg.passband_center=0;
fg.passband_direction=1;
//?????check_filtercorr_direction();
*/
}


void start_network_output(void)
{
int netdat[NETHEADER_SIZE];
netdat[0]=ui.input_speed;
netdat[1]=ui.ad_channels;
netdat[2]=ui.rx_channels;
netdat[3]=ui.input_mode;
netdat[4]=network_modeno;
netdat[5]=NETWORK_VERNR;
write(network_sockfd,netdat, NETHEADER_SIZE*sizeof(int));
}


void start_network_input(void)
{
/*
int netdat[NETHEADER_SIZE];
int i, j;
char s[80];
int client_sockfd;
fd_set readfds, testfds;
unsigned int nread; 
int fd, result, client_len;
struct sockaddr_in client_address;
network_address.sin_addr.s_addr = htonl(INADDR_ANY);
bind(network_sockfd, (struct sockaddr *)&network_address, 
                                               sizeof(network_address) );
listen(network_sockfd, 5);
FD_ZERO(&readfds);
FD_SET(network_sockfd, &readfds);
clear_screen();
j=4;
wait_for_net:;
testfds=readfds;
xytext(1,j,"Waiting for connection from network  (^C to exit)");
j++;
result = select(FD_SETSIZE, &testfds, (fd_set *)0,
                                 (fd_set *)0, (struct timeval *) 0);
if(result <1) 
  {
  perror("server5");
  exit(1);
  }
for(fd = 0; fd < FD_SETSIZE; fd++) 
  {
  if(FD_ISSET(fd,&testfds))
    {
    if(fd == network_sockfd) 
      {
      client_len = sizeof(client_address);
      client_sockfd = accept(network_sockfd,
              (struct sockaddr *)&client_address, (void*)&client_len);
      FD_SET(client_sockfd, &readfds);
      sprintf(s,"adding client on fd %d", client_sockfd); 
      xytext(1,j,s);
      j++;
      }
    else 
      {
      ioctl(fd, FIONREAD, &nread);
      if(nread ==0)
        {
        close (fd);
        FD_CLR(fd, &readfds);
        sprintf(s,"removing client on fd %d\n", fd);
        xytext(1,j,s);
        j++;
        }
      else 	
        {
// Check that we get the setup information correctly
// and exit if all seems ok.
        network_fd=fd;
        if(nread < NETHEADER_SIZE*sizeof(int))lir_sleep(10000);
        ioctl(network_fd, FIONREAD, &nread);
        netdat[5]=0;
        if(nread >= NETHEADER_SIZE*sizeof(int))
          {
          read(network_fd, netdat, NETHEADER_SIZE*sizeof(int));
          }
        ui.input_speed=netdat[0];
        ui.ad_channels=netdat[1];
        ui.rx_channels=netdat[2];
        ui.input_mode=netdat[3];
        network_modeno=netdat[4];
        if(netdat[5]==NETWORK_VERNR)
          {
          fft1mode=(ui.input_mode&(TWO_CHANNELS+IQ_DATA))/2;
          i=fft1_version[fft1mode][genparm[FIRST_FFT_VERNR]];
          if( i < 0 || i>=MAX_FFT_VERSIONS)genparm[FIRST_FFT_VERNR]=0;
          return;
          }
        xytext(1,j,"Data error");
        j++;
        }
      }
    }
  }
goto wait_for_net;
*/
}


void network_setup(int change)
{
int i;

      i=change; // (remove)
/*
int portno;
char netparms[NETPAR_FILESIZE],ip_addr[80],s[80];
FILE *file;
file = fopen(NETPAR_FILENAME, "r");
for(i=0; i<NETPAR_FILESIZE; i++)netparms[i]=0;
if (file == NULL)
  {
  if(change == 0)
    {
    network_flag=0;
    return;
    }
  }
else  
  {  
  i=fread(netparms,1,NETPAR_FILESIZE,file);
  fclose(file);
  }
for(i=0; i<24; i++)ip_addr[i]=0;
s[0]=0;
portno=9734;
network_modeno=0;  
sscanf(netparms,"%24s %d  %d",ip_addr,&portno,&network_modeno);
sel:;
if(change != 0)
  {
  clear_screen();
  xytext(3,3,"CURRENT NETWORK SETTINGS ARE:");
  sprintf(s,"IP address=%s      port=%d          ",ip_addr,portno);
  xytext(1,5,s);
  if(network_modeno > 2 || network_modeno < 0)network_modeno=0;
  sprintf(s,"Type of data: %s",netmodes[network_modeno]);
  xytext(1,6,s);
  xytext(8,9,"Press a key to change");
  xytext(8,11,"A => IP address");
  xytext(8,12,"B => Port");
  xytext(8,13,"C => Data type");
  xytext(8,14,"S => Save and exit");
  await_processed_keyboard();
  IFEXIT return;
  switch (lir_inkey)
    {
    case 'A':
    xytext(10,16,"New IP addr:");
    lir_get_filename(23,16,ip_addr);
    IFEXIT return;
    break;

    case 'B':
    xytext(10,16,"New port no:");
    portno=lir_get_integer(23,16,8,0,65535);
    IFEXIT return;
    break;

    case 'C':
    network_modeno++;
    if(network_modeno > 2)network_modeno=0;
    break;


    case 'S':
    file = fopen(NETPAR_FILENAME, "w");
    if (file == NULL)
      {
      lirerr(1144);
      return;
      }
    else  
      {  
      i=fwrite(netparms,1,NETPAR_FILESIZE,file);
      fclose(file);
      if(i != NETPAR_FILESIZE)
        {
        lirerr(1144);
        return;
        }
      }

    case 'X':
    goto netok;
    }
  sprintf(netparms,"%24s\n%d\n%d\n",ip_addr,portno,network_modeno);
  goto sel;
  }
netok:;
if(change == 0)
  {
  network_sockfd = socket(AF_INET, SOCK_STREAM, 0);
  network_address.sin_family = AF_INET;
  network_address.sin_addr.s_addr = inet_addr(ip_addr);
  network_address.sin_port = htons(portno);
  if(network_flag == 2)
    {
    start_network_input();
    }
  else
    {
    if(network_modeno != 0)
      {
retry_connect:;
      i = connect(network_sockfd, (struct sockaddr *)&network_address, 
                                               sizeof(network_address) );
      if(i == -1)
        {
        clear_screen();
        xytext(5,5,"FAILED TO CONNECT TO NETWORK");
        xytext(1,6,"Second computer not running in network mode ??");
        xytext(5,8,"Try again ? (Y/N)");
        await_processed_keyboard();
        if(lir_inkey != 'Y')return;
        goto retry_connect; 
        }
      network_flag=1;
      start_network_output();
      }
    } 
  }
*/
}

unsigned int network_wait(void)
{
/*
unsigned int i;
xytext(5,5,"WAITING FOR NETWORK DATA");
lir_sleep(10000);
ioctl(network_fd, FIONREAD, &i);
test_keyboard();
if(lir_inkey != 0)
  {
  process_current_lir_inkey();
  }
return i;
*/
// *******************************
return 0;
}


